include "basics/pts.ma".
include "connectives.ma".
axiom eq : \forall A : Type[0] . A -> A -> Prop.
axiom refl : \forall A. \forall (x:A). (eq) (A) x x.
axiom eq_ind : \forall A. \forall (x:A). \forall (P:A -> Prop). (P x) -> \forall (y:A). ((eq) (A) x y) -> P y.
definition rewrite_l : \forall A. \forall (x:A). \forall (P:A -> Prop). (P x) -> \forall (y:A). ((eq) (A) x y) -> P y := \lambda A : Type[0]. \lambda x : A. \lambda P : A -> Prop. \lambda Hx : P x. (\lambda y : A. \lambda Heq : (eq) (A) x y. (((((((eq_ind) (A)) (x)) (\lambda j__ : A. P j__)) (Hx)) (y)) (Heq))).
definition sym_eq : \forall A. \forall (x:A). \forall (y:A). ((eq) (A) x y) -> (eq) (A) y x := \lambda A : Type[0]. \lambda x : A. \lambda y : A. \lambda Heq : (eq) (A) x y. (((((((rewrite_l) (A)) (x)) (\lambda j__ : A. (eq) (A) j__ x)) (((refl) (A)) (x))) (y)) (((((((rewrite_l) (A)) (x)) (\lambda j__ : A. (eq) (A) x j__)) (((refl) (A)) (x))) (y)) (Heq))).
definition rewrite_r : \forall A. \forall (x:A). \forall (P:A -> Prop). (P x) -> \forall (y:A). ((eq) (A) y x) -> P y := \lambda A : Type[0]. \lambda x : A. \lambda P : A -> Prop. \lambda Hx : P x. (\lambda y : A. \lambda Heq : (eq) (A) y x. (((((((eq_ind) (A)) (x)) (\lambda j__ : A. P j__)) (Hx)) (y)) (((((sym_eq) (A)) (y)) (x)) (Heq)))).
definition absurd : \forall (A:Prop). (A) -> ((Not)  A) -> (False)  := \lambda A : Prop. \lambda H : A. (\lambda Hn : (Not)  A. (((((Not_ind) (A)) ((False) )) (\lambda j_x_80 : (A) -> (False) . ((j_x_80) (H)))) (Hn))).
definition sym_not_eq : \forall A. \forall (x:A). \forall (y:A). ((Not)  ((eq) (A) x y)) -> (Not)  ((eq) (A) y x) := \lambda A : Type[0]. \lambda x : A. \lambda y : A. \lambda auto : (Not)  ((eq) (A) x y). (((nmk) ((eq) (A) y x)) (\lambda auto' : (eq) (A) y x. ((((absurd) ((eq) (A) x y)) (((((((rewrite_r) (A)) (x)) (\lambda j__ : A. (eq) (A) x j__)) (((refl) (A)) (x))) (y)) (auto'))) (auto)))).
